unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, LCLType, ExtCtrls, Math, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure palyafrissites(Sender: TObject);
    procedure ellvezerles(Sender: TObject);
    procedure kilepgombkatt(Sender: TObject);
    procedure jatvegegombkatt(Sender: TObject);
  private

  public

  end;

type Tpuffancsok = class(TObject)
  private
  public
    xhely,yhely,celx,cely,celindex,elozoxh,elozoyh,lotav: integer;
    iranya: double;
    kepe: TBitmap;
    mitcsinal,neve: string;
    sebessege,kanyardb,kikerirany,epsege,maxepsege,tulaj,tamadoero: byte;
    kijelolt,letezik: boolean;
end;

type Tepuletek = class(TObject)
  private
  public
    xhely,yhely,lotav: integer;
    kepe: TBitmap;
    tulaj,epsege,maxepsege,kepezpuffdb,kepezkozkatdb,kepezido,lohetvsz: byte;
    kijelolt,uzemkesz,lohet,letezik: boolean;
    neve,mitkepez: string;
end;

type Tgombok = class(TObject)
  private
  public
    xhely,yhely,gazdaepulete: integer;
    kepe: TBitmap;
    neve: string;
end;

type Tepitendo = class(TObject)
  private
  public
    xhely,yhely: integer;
    kepe: TBitmap;
    neve: string;
end;

var
  Form1: TForm1;
  palyakep,hudpanelkep,foepkep,lakohazkep,laktkep,leztorkep,ellfoepkep,elllakohazkep,elllaktkep,ellleztorkep,epitikonkep,lebontikonkep,foepikonkep,lakohazikonkep,laktanyaikonkep,lezertoronyikonkep,puffikonkep,kozkatikonkep: TBitmap;
  palyafrissito,ellvezerlo: TTimer;
  palyakepx,palyakepy,puffancsdb,epuletdb,kijkerkx,kijkerky,kijkervx,kijkervy,gombgazda: integer;
  puffancskep: array [0..7] of TBitmap;
  kozkatkep: array [0..7] of TBitmap;
  ellpuffancskep: array [0..7] of TBitmap;
  ellkozkatkep: array [0..7] of TBitmap;
  puffancs: array of Tpuffancsok;
  epuletek: array of Tepuletek;
  gombok: array of Tgombok;
  kilepgomb,jvgomb: TButton;
  epitendo: Tepitendo;
  nyelv,gombdb: byte;
  ellcselekedhet: boolean;
  cselekves: string;

implementation

{$R *.lfm}

{ TForm1 }

function palyanvan(xhely: integer; yhely: integer): boolean;
begin
 if (xhely>palyakepx) and (xhely<palyakep.canvas.width) and (yhely>palyakepy) and (yhely<palyakep.canvas.height-hudpanelkep.height) then
    palyanvan:=true
 else
     palyanvan:=false;
end;

function ponttav(x1: integer; y1: integer; x2: integer; y2: integer): double;
begin
  ponttav:=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
end;

function tavolsag(xhely1: integer; yhely1: integer; terszel1: integer; termag1: integer; xhely2: integer; yhely2: integer; terszel2: integer; termag2: integer): double;
var utkertek: boolean;
begin
 utkertek:=(abs(xhely1-xhely2)*2<(terszel1+terszel2)) and (abs(yhely1-yhely2)*2<(termag1+termag2));
 if utkertek=true then
    tavolsag:=0
 else
 begin
        if (xhely2>xhely1+terszel1) and (yhely2+termag2<yhely1) then // Jobbrafenn:
            tavolsag:=ponttav(xhely1+terszel1,yhely1,xhely2,yhely2+termag2)
        else
        if (xhely2>xhely1+terszel1) and (yhely2>yhely1+termag1) then // Jobbralenn:
            tavolsag:=ponttav(xhely1+terszel1,yhely1+termag1,xhely2,yhely2)
        else
        if (xhely2+terszel2<xhely1) and (yhely2+termag2<yhely1) then // Balrafenn:
            tavolsag:=ponttav(xhely1,yhely1,xhely2+terszel2,yhely2+termag2)
        else
        if (xhely2+terszel2<xhely1) and (yhely2>yhely1+termag1) then // Balralenn:
            tavolsag:=ponttav(xhely1,yhely1+termag1,xhely2+terszel2,yhely2)
        else
        if xhely2>xhely1+terszel1 then // Jobbra:
            tavolsag:=xhely2-(xhely1+terszel1)
        else
        if xhely2+terszel2<xhely1 then // Balra:
            tavolsag:=xhely1-(xhely2+terszel2)
        else
        if yhely2+termag2<yhely1 then // Fenn:
            tavolsag:=yhely1-(yhely2+termag2)
        else
        if yhely2>yhely1+termag1 then // Lenn:
            tavolsag:=yhely2-(yhely1+termag1);
 end;
end;

function pontirany(x1: integer; y1: integer; x2: integer; y2: integer): double;
var szam: double;
begin
  szam:=arctan2(y2-y1,x2-x1);
  if szam<0 then szam:=szam+2*pi;
  pontirany:=360-(szam*180)/pi;
end;

function ureshely(xh: integer; yh: integer; szel: integer; mag: integer): boolean;
var i: integer;
  ertek: boolean;
begin
  ertek:=true;
  for i:=0 to epuletdb-1 do
  begin
   if (xh-round(szel/2) < epuletek[i].xhely-round(epuletek[i].kepe.width/2) + epuletek[i].kepe.width) and
        (xh-round(szel/2) + szel > epuletek[i].xhely-round(epuletek[i].kepe.width/2)) and
        (yh-round(mag/2) < epuletek[i].yhely-round(epuletek[i].kepe.height/2) + epuletek[i].kepe.height) and
        (yh-round(mag/2) + mag > epuletek[i].yhely-round(epuletek[i].kepe.height/2)) then
        begin
          ertek:=false;
          break;
        end;
  end;
  ureshely:=ertek;
end;

function utkitt(ittx: integer; itty: integer; szel: integer; mag: integer): boolean;
var i: integer;
  ertek: boolean;
begin
  ertek:=false;
  for i:=0 to puffancsdb-1 do
  begin
     if (ittx-round(szel/2) < puffancs[i].xhely-round(puffancs[i].kepe.width/2) + puffancs[i].kepe.width) and
          (ittx-round(szel/2) + szel > puffancs[i].xhely-round(puffancs[i].kepe.width/2)) and
          (itty-round(mag/2) < puffancs[i].yhely-round(puffancs[i].kepe.height/2) + puffancs[i].kepe.height) and
          (itty-round(mag/2) + mag > puffancs[i].yhely-round(puffancs[i].kepe.height/2)) then
          begin
            ertek:=true;
            break;
          end;
  end;
  utkitt:=ertek;
end;

function puffcelkozelben(i: integer; celtipus: byte): boolean;
var e: integer;
  ertek: boolean;
begin
  ertek:=false;
  case celtipus of
   0: begin //Épület:
    for e:=0 to epuletdb-1 do
    begin
     if (puffancs[i].celindex=e) and (tavolsag(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height,epuletek[e].xhely,epuletek[e].yhely,epuletek[e].kepe.width,epuletek[e].kepe.height)<=puffancs[i].lotav) then
     begin
       ertek:=true;
       break;
     end;
    end;
   end;
   1: begin //Egység:
    for e:=0 to puffancsdb-1 do
    begin
     if (puffancs[i].celindex=e) and (tavolsag(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height,puffancs[e].xhely,puffancs[e].yhely,puffancs[e].kepe.width,puffancs[e].kepe.height)<=puffancs[i].lotav) then
     begin
       ertek:=true;
       break;
     end;
    end;
   end;
  end;
  puffcelkozelben:=ertek;
end;

procedure jatekvegeell();
var i: integer;
  vanmegjategys,vanmegellegys,vanmegjatep,vanmegellep: boolean;
begin
 vanmegjategys:=false;
 vanmegellegys:=false;
 for i:=0 to puffancsdb-1 do
 begin
   if puffancs[i].tulaj=0 then
      vanmegjategys:=true
   else
       vanmegellegys:=true;
 end;
 vanmegjatep:=false;
 vanmegellep:=false;
 for i:=0 to epuletdb-1 do
 begin
   if epuletek[i].tulaj=0 then
      vanmegjatep:=true
   else
       vanmegellep:=true;
 end;
 if (vanmegjategys=false) and (vanmegjatep=false) then
 begin
   jvgomb:=TButton.Create(Form1);
   With jvgomb do
   begin
      Left:=round(Form1.width/2);
      top:=round(Form1.height/2);
      case nyelv of
       0: Caption:='Vesztettél...';
       1: Caption:='You lost...';
      end;
      parent:=Form1;
      Onclick:=@Form1.jatvegegombkatt;
      OnKeyDown:=@Form1.FormKeyDown
   end;
 end
 else
 if (vanmegellegys=false) and (vanmegellep=false) then
 begin
   jvgomb:=TButton.Create(Form1);
   With jvgomb do
   begin
      Left:=round(Form1.width/2);
      top:=round(Form1.height/2);
      case nyelv of
       0: Caption:='Győzelem!';
       1: Caption:='Victory!';
      end;
      parent:=Form1;
      Onclick:=@Form1.jatvegegombkatt;
      OnKeyDown:=@Form1.FormKeyDown
   end;
 end;
end;

procedure gombtorles();
var i: byte;
begin
  if gombdb>0 then
  begin
     for i:=0 to gombdb-1 do
     begin
      gombok[i].free;
     end;
     gombdb:=0;
  end;
end;

procedure epitendocsinalo(milyet: string);
begin
  cselekves:='nincs';
  epitendo:=Tepitendo.Create;
  case milyet of
   'foepulet': epitendo.kepe:=foepkep;
   'lakohaz': epitendo.kepe:=lakohazkep;
   'laktanya': epitendo.kepe:=laktkep;
   'lezertorony': epitendo.kepe:=leztorkep;
  end;
  epitendo.xhely:=mouse.cursorpos.X-round(epitendo.kepe.width/2);
  epitendo.yhely:=mouse.cursorpos.Y-round(epitendo.kepe.height/2);
  epitendo.neve:=milyet;
end;

procedure gombkirako(tipus: byte; epuletindexe: integer);
var i: byte;
begin
  cselekves:='nincs';
  gombtorles();
  case tipus of
    0: begin
     setlength(gombok,gombdb+1);
     gombok[gombdb]:=Tgombok.Create;
     gombok[gombdb].xhely:=kilepgomb.width+4;
     gombok[gombdb].yhely:=kilepgomb.top;
     gombok[gombdb].kepe:=epitikonkep;
     gombok[gombdb].gazdaepulete:=epuletindexe;
     gombok[gombdb].neve:='epit';
     inc(gombdb,1);
     setlength(gombok,gombdb+1);
     gombok[gombdb]:=Tgombok.Create;
     gombok[gombdb].xhely:=gombok[gombdb-1].xhely+gombok[gombdb-1].kepe.width+4;
     gombok[gombdb].yhely:=kilepgomb.top;
     gombok[gombdb].kepe:=lebontikonkep;
     gombok[gombdb].gazdaepulete:=epuletindexe;
     gombok[gombdb].neve:='lebont';
     inc(gombdb,1);
    end;
    1: begin
     for i:=0 to 3 do
     begin
          setlength(gombok,gombdb+1);
          gombok[gombdb]:=Tgombok.Create;
          gombok[gombdb].yhely:=kilepgomb.top;
          gombok[gombdb].gazdaepulete:=epuletindexe;
          case i of
            0: begin
             gombok[gombdb].xhely:=kilepgomb.width+4;
             gombok[gombdb].kepe:=foepikonkep;
             gombok[gombdb].neve:='foepulet';
            end;
            1: begin
             gombok[gombdb].xhely:=gombok[gombdb-1].xhely+gombok[gombdb-1].kepe.width+4;
             gombok[gombdb].kepe:=lakohazikonkep;
             gombok[gombdb].neve:='lakohaz';
            end;
            2: begin
             gombok[gombdb].xhely:=gombok[gombdb-1].xhely+gombok[gombdb-1].kepe.width+4;
             gombok[gombdb].kepe:=laktanyaikonkep;
             gombok[gombdb].neve:='laktanya';
            end;
            3: begin
             gombok[gombdb].xhely:=gombok[gombdb-1].xhely+gombok[gombdb-1].kepe.width+4;
             gombok[gombdb].kepe:=lezertoronyikonkep;
             gombok[gombdb].neve:='lezertorony';
            end;
          end;
          inc(gombdb,1);
     end;
    end;
    2: begin
     setlength(gombok,gombdb+1);
     gombok[gombdb]:=Tgombok.Create;
     gombok[gombdb].xhely:=kilepgomb.width+4;
     gombok[gombdb].yhely:=kilepgomb.top;
     gombok[gombdb].kepe:=puffikonkep;
     gombok[gombdb].gazdaepulete:=epuletindexe;
     gombok[gombdb].neve:='puffancs';
     inc(gombdb,1);
    end;
    3: begin
     setlength(gombok,gombdb+1);
     gombok[gombdb]:=Tgombok.Create;
     gombok[gombdb].xhely:=kilepgomb.width+4;
     gombok[gombdb].yhely:=kilepgomb.top;
     gombok[gombdb].kepe:=kozkatikonkep;
     gombok[gombdb].gazdaepulete:=epuletindexe;
     gombok[gombdb].neve:='kozkatona';
     inc(gombdb,1);
    end;
  end;
end;

procedure egysegcsinalo(neve: string; idex: integer; idey: integer; tul: byte);
var puffalkepe: byte;
begin
    setlength(puffancs,puffancsdb+1);
    puffancs[puffancsdb]:=Tpuffancsok.create;
    puffancs[puffancsdb].xhely:=idex;
    puffancs[puffancsdb].yhely:=idey;
    puffancs[puffancsdb].iranya:=0;
    puffancs[puffancsdb].kikerirany:=0;
    puffancs[puffancsdb].mitcsinal:='semmit';
    puffancs[puffancsdb].kijelolt:=false;
    puffancs[puffancsdb].tulaj:=tul;
    puffancs[puffancsdb].neve:=neve;
    puffancs[puffancsdb].letezik:=true;
    case neve of
      'puffancs': begin
                   puffalkepe:=trunc(puffancs[puffancsdb].iranya*8/360);
                   if puffalkepe>7 then puffalkepe:=0;
                   puffancs[puffancsdb].kepe:=puffancskep[puffalkepe];
                   puffancs[puffancsdb].sebessege:=2;
                   puffancs[puffancsdb].tamadoero:=1;
                   puffancs[puffancsdb].maxepsege:=100;
       end;
      'kozkatona': begin
                   puffalkepe:=trunc(puffancs[puffancsdb].iranya*8/360);
                   if puffalkepe>7 then puffalkepe:=0;
                   puffancs[puffancsdb].kepe:=kozkatkep[puffalkepe];
                   puffancs[puffancsdb].sebessege:=4;
                   puffancs[puffancsdb].tamadoero:=2;
                   puffancs[puffancsdb].maxepsege:=150;
       end;
      'ellpuffancs': begin
                   puffalkepe:=trunc(puffancs[puffancsdb].iranya*8/360);
                   if puffalkepe>7 then puffalkepe:=0;
                   puffancs[puffancsdb].kepe:=ellpuffancskep[puffalkepe];
                   puffancs[puffancsdb].sebessege:=2;
                   puffancs[puffancsdb].tamadoero:=1;
                   puffancs[puffancsdb].maxepsege:=100;
       end;
      'ellkozkatona': begin
                   puffalkepe:=trunc(puffancs[puffancsdb].iranya*8/360);
                   if puffalkepe>7 then puffalkepe:=0;
                   puffancs[puffancsdb].kepe:=ellkozkatkep[puffalkepe];
                   puffancs[puffancsdb].sebessege:=4;
                   puffancs[puffancsdb].tamadoero:=2;
                   puffancs[puffancsdb].maxepsege:=150;
       end;
     end;
    puffancs[puffancsdb].epsege:=puffancs[puffancsdb].maxepsege;
    puffancs[puffancsdb].lotav:=round(ponttav(puffancs[puffancsdb].xhely,puffancs[puffancsdb].yhely,puffancs[puffancsdb].xhely+puffancs[puffancsdb].kepe.width,puffancs[puffancsdb].yhely+puffancs[puffancsdb].kepe.height)*2);
    inc(puffancsdb,1)
end;

procedure egyskirakide(idex: integer; idey: integer; neve: string; gyarx: integer; gyary: integer; gyarszel: integer; gyarmag: integer; tul: byte);
var okehely,palyaoke,epuletoke,korbement: boolean;
    keresosugar: byte;
    startx,egysszel,egysmag,keresoirany: integer;
begin
     okehely:=false;
     palyaoke:=false;
     epuletoke:=true;
     korbement:=false;
     keresosugar:=0;
     keresoirany:=180;
     startx:=idex;
     case neve of
       'puffancs','ellpuffancs': begin
        egysszel:=puffancskep[0].width;
        egysmag:=puffancskep[0].height;
       end;
       'kozkatona','ellkozkatona': begin
        egysszel:=kozkatkep[0].width;
        egysmag:=kozkatkep[0].height;
       end;
     end;
     repeat
       palyaoke:=false;
       epuletoke:=true;
       if (idex>2) and (idex+egysszel<palyakep.canvas.width-2) and (idey-egysmag>2) and (idey+egysmag<palyakep.canvas.height-2) then palyaoke:=true;
       epuletoke:=ureshely(idex,idey,egysszel,egysmag);
       if (palyaoke=true) and (epuletoke=true) then
          okehely:=true
       else
       begin
            case keresoirany of
              0: begin
                 idex:=idex+egysszel;
                 if (idex>gyarx+gyarszel+(keresosugar*gyarszel)) then keresoirany:=270;
              end;
              90: begin
                  idey:=idey-egysmag;
                  if idey+gyarmag<gyary-(keresosugar*gyarmag) then keresoirany:=0;
              end;
              180: begin
                   idex:=idex-egysszel;
                   if (korbement=true) and (idex<startx) then
                   begin
                        idey:=idey+egysmag;
                        keresosugar:=keresosugar+1;
                        korbement:=false;
                   end
                   else
                   if (idex+egysszel<gyarx-(keresosugar*gyarszel)) then keresoirany:=90;
              end;
              270: begin
                   idey:=idey+egysmag;
                   if (idey>gyary+gyarmag+(keresosugar*gyarmag)) then
                   begin
                      keresoirany:=180;
                      korbement:=true;
                   end;
                end;
            end;
       end;
     until okehely=true;
     egysegcsinalo(neve,idex,idey,tul);
end;

procedure epuletcsinalo(neve: string; idex: integer; idey: integer; eps: byte; tul: byte);
begin
  setlength(epuletek,epuletdb+1);
  epuletek[epuletdb]:=Tepuletek.create;
  epuletek[epuletdb].xhely:=idex;
  epuletek[epuletdb].yhely:=idey;
  epuletek[epuletdb].kijelolt:=false;
  epuletek[epuletdb].neve:=neve;
  epuletek[epuletdb].epsege:=eps;
  epuletek[epuletdb].mitkepez:='semmit';
  epuletek[epuletdb].kepezido:=0;
  epuletek[epuletdb].tulaj:=tul;
  epuletek[epuletdb].letezik:=true;
  case neve of
    'foepulet':
      begin
           epuletek[epuletdb].kepe:=foepkep;
           epuletek[epuletdb].kepezpuffdb:=0;
           epuletek[epuletdb].maxepsege:=255;
      end;
    'lakohaz':
      begin
           epuletek[epuletdb].kepe:=lakohazkep;
           epuletek[epuletdb].maxepsege:=150;
      end;
    'laktanya':
      begin
           epuletek[epuletdb].kepe:=laktkep;
           epuletek[epuletdb].kepezkozkatdb:=0;
           epuletek[epuletdb].maxepsege:=250;
      end;
    'lezertorony':
      begin
           epuletek[epuletdb].kepe:=leztorkep;
           epuletek[epuletdb].maxepsege:=200;
           epuletek[epuletdb].lohet:=true;
           epuletek[epuletdb].lohetvsz:=0;
           epuletek[epuletdb].lotav:=round(ponttav(epuletek[epuletdb].xhely,epuletek[epuletdb].yhely,epuletek[epuletdb].xhely+epuletek[epuletdb].kepe.width,epuletek[epuletdb].yhely+epuletek[epuletdb].kepe.height)*4);
      end;
    'ellfoepulet':
      begin
           epuletek[epuletdb].kepe:=ellfoepkep;
           epuletek[epuletdb].kepezpuffdb:=0;
           epuletek[epuletdb].maxepsege:=255;
      end;
    'elllakohaz':
      begin
           epuletek[epuletdb].kepe:=elllakohazkep;
           epuletek[epuletdb].maxepsege:=150;
      end;
    'elllaktanya':
      begin
           epuletek[epuletdb].kepe:=elllaktkep;
           epuletek[epuletdb].kepezkozkatdb:=0;
           epuletek[epuletdb].maxepsege:=250;
      end;
    'elllezertorony':
      begin
           epuletek[epuletdb].kepe:=ellleztorkep;
           epuletek[epuletdb].maxepsege:=200;
           epuletek[epuletdb].lohet:=true;
           epuletek[epuletdb].lohetvsz:=0;
           epuletek[epuletdb].lotav:=round(ponttav(epuletek[epuletdb].xhely,epuletek[epuletdb].yhely,epuletek[epuletdb].xhely+epuletek[epuletdb].kepe.width,epuletek[epuletdb].yhely+epuletek[epuletdb].kepe.height)*4);
      end;
  end;
  if epuletek[epuletdb].epsege=epuletek[epuletdb].maxepsege then
     epuletek[epuletdb].uzemkesz:=true
  else epuletek[epuletdb].uzemkesz:=false;
  inc(epuletdb,1);
end;

procedure kiutkeres(indexe: integer; sx: integer; sy: integer; szel: integer; mag: integer);
var szorzo, szdb, vsz: byte;
    vankiut: Boolean;
    szabhelyek: array [0..7,0..1] of integer;
begin
    szorzo:=1;
    szdb:=0;
    vankiut:=false;
    repeat
     if (utkitt(sx,sy-mag*szorzo,szel,mag)=false) and (palyanvan(sx,sy-mag*szorzo)=true) and (ureshely(sx,sy-mag*szorzo,szel,mag)=true) then //Fenn
     begin
       szabhelyek[szdb,0]:=sx;
       szabhelyek[szdb,1]:=sy-mag*szorzo;
       szdb:=szdb+1;
     end;
     if (utkitt(sx+szel*szorzo,sy-mag*szorzo,szel,mag)=false) and (palyanvan(sx+szel*szorzo,sy-mag*szorzo)=true) and (ureshely(sx+szel*szorzo,sy-mag*szorzo,szel,mag)=true) then //Jobbra fenn
     begin
       szabhelyek[szdb,0]:=sx+szel*szorzo;
       szabhelyek[szdb,1]:=sy-mag*szorzo;
       szdb:=szdb+1;
     end;
     if (utkitt(sx+szel*szorzo,sy,szel,mag)=false) and (palyanvan(sx+szel*szorzo,sy)=true) and (ureshely(sx+szel*szorzo,sy,szel,mag)=true) then //Jobbra
     begin
       szabhelyek[szdb,0]:=sx+szel*szorzo;
       szabhelyek[szdb,1]:=sy;
       szdb:=szdb+1;
     end;
     if (utkitt(sx+szel*szorzo,sy+mag*szorzo,szel,mag)=false) and (palyanvan(sx+szel*szorzo,sy+mag*szorzo)=true) and (ureshely(sx+szel*szorzo,sy+mag*szorzo,szel,mag)=true) then //Jobbra lenn
     begin
       szabhelyek[szdb,0]:=sx+szel*szorzo;
       szabhelyek[szdb,1]:=sy+mag*szorzo;
       szdb:=szdb+1;
     end;
     if (utkitt(sx,sy+mag*szorzo,szel,mag)=false) and (palyanvan(sx,sy+mag*szorzo)=true) and (ureshely(sx,sy+mag*szorzo,szel,mag)=true) then //Lenn
     begin
       szabhelyek[szdb,0]:=sx;
       szabhelyek[szdb,1]:=sy+mag*szorzo;
       szdb:=szdb+1;
     end;
     if (utkitt(sx-szel*szorzo,sy+mag*szorzo,szel,mag)=false) and (palyanvan(sx-szel*szorzo,sy+mag*szorzo)=true) and (ureshely(sx-szel*szorzo,sy+mag*szorzo,szel,mag)=true) then //Balra lenn
     begin
       szabhelyek[szdb,0]:=sx-szel*szorzo;
       szabhelyek[szdb,1]:=sy+mag*szorzo;
       szdb:=szdb+1;
     end;
     if (utkitt(sx-szel*szorzo,sy,szel,mag)=false) and (palyanvan(sx-szel*szorzo,sy)=true) and (ureshely(sx-szel*szorzo,sy,szel,mag)=true) then //Balra
     begin
       szabhelyek[szdb,0]:=sx-szel*szorzo;
       szabhelyek[szdb,1]:=sy;
       szdb:=szdb+1;
     end;
     if (utkitt(sx-szel*szorzo,sy-mag*szorzo,szel,mag)=false) and (palyanvan(sx-szel*szorzo,sy-mag*szorzo)=true) and (ureshely(sx-szel*szorzo,sy-mag*szorzo,szel,mag)=true) then //Balra fenn
     begin
       szabhelyek[szdb,0]:=sx-szel*szorzo;
       szabhelyek[szdb,1]:=sy-mag*szorzo;
       szdb:=szdb+1;
     end;
     if szdb>0 then vankiut:=true else
     begin
      szdb:=0;
      szorzo:=szorzo+1;
     end;
    until vankiut=true;
    vsz:=random(szdb);
    puffancs[indexe].celx:=szabhelyek[vsz,0];
    puffancs[indexe].cely:=szabhelyek[vsz,1];
    puffancs[indexe].mitcsinal:='kijon';
end;

procedure utkellenorzes(ki: integer);
var i: integer;
begin
     for i:=0 to puffancsdb-1 do
     begin
      if ki<>i then begin
        if (puffancs[ki].xhely-round(puffancs[ki].kepe.width/2) < puffancs[i].xhely-round(puffancs[i].kepe.width/2) + puffancs[i].kepe.width) and
        (puffancs[ki].xhely-round(puffancs[ki].kepe.width/2) + puffancs[ki].kepe.width > puffancs[i].xhely-round(puffancs[i].kepe.width/2)) and
        (puffancs[ki].yhely-round(puffancs[ki].kepe.height/2) < puffancs[i].yhely-round(puffancs[i].kepe.height/2) + puffancs[i].kepe.height) and
        (puffancs[ki].yhely-round(puffancs[ki].kepe.height/2) + puffancs[ki].kepe.height > puffancs[i].yhely-round(puffancs[i].kepe.height/2)) then
        begin
          kiutkeres(ki,puffancs[ki].xhely-round(puffancs[ki].kepe.width/2),puffancs[ki].yhely-round(puffancs[ki].kepe.height/2),puffancs[ki].kepe.width,puffancs[ki].kepe.height);
          break;
        end;
      end;
     end;
end;

procedure epsegmutato(xh: integer; yh: integer; kepszel: integer; eps: byte; maxeps: byte);
var eletszazalek,csikszazalek: word;
begin
     Form1.Canvas.Brush.Color:=clGray;
     Form1.Canvas.Rectangle(xh,yh-8,xh+kepszel,yh);
     if eps<round(maxeps/2) then Form1.Canvas.Brush.Color:=clRed
     else Form1.Canvas.Brush.Color:=clYellow;
     eletszazalek:=round((100*eps)/maxeps);
     csikszazalek:=round((kepszel*eletszazalek)/100);
     Form1.Canvas.Rectangle(xh,yh-8,xh+csikszazalek,yh);
end;

procedure TForm1.palyafrissites(Sender: TObject);
var kovx,kovy,i,e,p: integer;
    puffalkepe,joiranydb: byte;
    iranytomb: array [0..3] of byte;
    vancelpont: boolean;
begin
  for e:=0 to epuletdb-1 do
  begin
   if epuletek[e].letezik=false then
   begin
     delete(epuletek,e,1);
     epuletdb:=epuletdb-1;
     jatekvegeell();
   end
   else
   begin
   case epuletek[e].neve of
        'lezertorony','elllezertorony': begin
         if epuletek[e].lohetvsz>0 then
            epuletek[e].lohetvsz:=epuletek[e].lohetvsz-1
         else
         begin
           epuletek[e].lohet:=not(epuletek[e].lohet);
           if epuletek[e].lohet=false then epuletek[e].lohetvsz:=100;
         end;
         if epuletek[e].lohet=true then
         begin
           for i:=0 to puffancsdb-1 do
           begin
            if (puffancs[i].tulaj<>epuletek[e].tulaj) and (ponttav(epuletek[e].xhely+round(epuletek[e].kepe.width/2),epuletek[e].yhely,puffancs[i].xhely-round(puffancs[i].kepe.width/2),puffancs[i].yhely-round(puffancs[i].kepe.height/2))<=epuletek[e].lotav) then
            begin
                 Canvas.Pen.Color:=clRed;
                 Canvas.Pen.Width:=2;
                 Canvas.MoveTo(palyakepx+epuletek[e].xhely,palyakepy+epuletek[e].yhely-round(epuletek[e].kepe.height/2));
                 Canvas.LineTo(palyakepx+puffancs[i].xhely,palyakepy+puffancs[i].yhely);
                 if (puffancs[i].epsege-5>=0) and (epuletek[e].lohetvsz=0) then
                 begin
                      puffancs[i].epsege:=puffancs[i].epsege-5;
                      epuletek[e].lohetvsz:=100;
                 end
                 else
                 if puffancs[i].epsege<1 then
                 begin
                      for p:=0 to puffancsdb-1 do
                      begin
                           if puffancs[p].celindex=i then puffancs[p].mitcsinal:='semmit';
                      end;
                      puffancs[i].letezik:=false;
                 end;
             end;
             break;
            end;
           end;
         end;
   end;
   case epuletek[e].mitkepez of
     'semmit': begin
       if (epuletek[e].tulaj<>0) and (random(50)+1=1) and (ellcselekedhet=true) then
       begin
         case epuletek[e].neve of
           'ellfoepulet': epuletek[e].mitkepez:='ellpuffancs';
           'elllaktanya': epuletek[e].mitkepez:='ellkozkatona';
         end;
       end;
      end;
     'puffancs': begin
       if epuletek[e].kepezido<100 then
       begin
         epuletek[e].kepezido:=epuletek[e].kepezido+1;
       end
       else
       begin
         epuletek[e].kepezido:=0;
         egyskirakide(epuletek[e].xhely,epuletek[e].yhely+epuletek[e].kepe.height+4,'puffancs',epuletek[e].xhely,epuletek[e].yhely,epuletek[e].kepe.width,epuletek[e].kepe.height,epuletek[e].tulaj);
         epuletek[e].kepezpuffdb:=epuletek[e].kepezpuffdb-1;
         if epuletek[e].kepezpuffdb<1 then epuletek[e].mitkepez:='semmit';
       end;
     end;
     'kozkatona': begin
       if epuletek[e].kepezido<150 then
       begin
         epuletek[e].kepezido:=epuletek[e].kepezido+1;
       end
       else
       begin
         epuletek[e].kepezido:=0;
         egyskirakide(epuletek[e].xhely,epuletek[e].yhely+epuletek[e].kepe.height+4,'kozkatona',epuletek[e].xhely,epuletek[e].yhely,epuletek[e].kepe.width,epuletek[e].kepe.height,epuletek[e].tulaj);
         epuletek[e].kepezkozkatdb:=epuletek[e].kepezkozkatdb-1;
         if epuletek[e].kepezkozkatdb<1 then epuletek[e].mitkepez:='semmit';
       end;
      end;
     'ellpuffancs': begin
       if epuletek[e].kepezido<100 then
       begin
         epuletek[e].kepezido:=epuletek[e].kepezido+1;
       end
       else
       begin
         epuletek[e].kepezido:=0;
         egyskirakide(epuletek[e].xhely,epuletek[e].yhely+epuletek[e].kepe.height+4,'ellpuffancs',epuletek[e].xhely,epuletek[e].yhely,epuletek[e].kepe.width,epuletek[e].kepe.height,epuletek[e].tulaj);
         epuletek[e].mitkepez:='semmit';
       end;
     end;
     'ellkozkatona': begin
       if epuletek[e].kepezido<150 then
       begin
         epuletek[e].kepezido:=epuletek[e].kepezido+1;
       end
       else
       begin
         epuletek[e].kepezido:=0;
         egyskirakide(epuletek[e].xhely,epuletek[e].yhely+epuletek[e].kepe.height+4,'ellkozkatona',epuletek[e].xhely,epuletek[e].yhely,epuletek[e].kepe.width,epuletek[e].kepe.height,epuletek[e].tulaj);
         epuletek[e].mitkepez:='semmit';
       end;
      end;
     end;
   end;
  end;
  for i:=0 to puffancsdb-1 do
  begin
   if puffancs[i].letezik=false then
   begin
     if gombgazda=i then
     begin
       gombtorles();
       if epitendo<>nil then
       begin
            epitendo.free;
            epitendo:=nil;
       end;
       gombgazda:=-1;
     end;
     delete(puffancs,i,1);
     puffancsdb:=puffancsdb-1;
     jatekvegeell();
   end
   else
   begin
    case puffancs[i].mitcsinal of
     'megy','kijon','megybontani','megyepiteni','uldoz': begin
      if puffancs[i].mitcsinal='uldoz' then //Ha követ valakit, akkor a céliránya felé tart-e?
      begin
        if (puffancs[i].celx<>puffancs[puffancs[i].celindex].xhely) or (puffancs[i].cely<>puffancs[puffancs[i].celindex].yhely) then
        begin
             puffancs[i].celx:=puffancs[puffancs[i].celindex].xhely;
             puffancs[i].cely:=puffancs[puffancs[i].celindex].yhely;
        end;
      end;
      //Itt jön az útvonalkeresés és akadálykikerülés:
      if puffancs[i].celx>puffancs[i].xhely then
      begin
         if abs(puffancs[i].celx-puffancs[i].xhely)>puffancs[i].sebessege then
            kovx:=puffancs[i].xhely+puffancs[i].sebessege
         else
             kovx:=puffancs[i].xhely+abs(puffancs[i].celx-puffancs[i].xhely);
      end
      else if puffancs[i].celx<puffancs[i].xhely then
      begin
         if abs(puffancs[i].celx-puffancs[i].xhely)<puffancs[i].sebessege then
            kovx:=puffancs[i].xhely-abs(puffancs[i].celx-puffancs[i].xhely)
         else
             kovx:=puffancs[i].xhely-puffancs[i].sebessege;
      end
      else
         kovx:=puffancs[i].xhely;
      if puffancs[i].cely>puffancs[i].yhely then
      begin
         if abs(puffancs[i].cely-puffancs[i].yhely)>puffancs[i].sebessege then
            kovy:=puffancs[i].yhely+puffancs[i].sebessege
         else
             kovy:=puffancs[i].yhely+abs(puffancs[i].cely-puffancs[i].yhely);
      end
      else if puffancs[i].cely<puffancs[i].yhely then
      begin
         if abs(puffancs[i].cely-puffancs[i].yhely)<puffancs[i].sebessege then
            kovy:=puffancs[i].yhely-abs(puffancs[i].cely-puffancs[i].yhely)
         else
             kovy:=puffancs[i].yhely-puffancs[i].sebessege;
      end
      else
         kovy:=puffancs[i].yhely;
      //
      if ponttav(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].celx,puffancs[i].cely)<=puffancs[i].sebessege then
         puffancs[i].mitcsinal:='semmit'
      else
      if (puffancs[i].mitcsinal='megybontani') and (puffcelkozelben(i,0)=true) then puffancs[i].mitcsinal:='lebont'
      else
      if (puffancs[i].mitcsinal='megyepiteni') and (puffcelkozelben(i,0)=true) then puffancs[i].mitcsinal:='epit'
      else
      if (puffancs[i].mitcsinal='uldoz') and (puffcelkozelben(i,1)=true) then puffancs[i].mitcsinal:='harcol'
      else
      if (ureshely(kovx,kovy,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (puffancs[i].kikerirany=0) then
      begin
              puffancs[i].iranya:=pontirany(puffancs[i].xhely,puffancs[i].yhely,kovx,kovy);
              puffancs[i].xhely:=kovx;
              puffancs[i].yhely:=kovy;
              puffalkepe:=trunc(puffancs[i].iranya*8/360);
              if puffalkepe>7 then puffalkepe:=0;
              case puffancs[i].neve of
               'puffancs': puffancs[i].kepe:=puffancskep[puffalkepe];
               'kozkatona': puffancs[i].kepe:=kozkatkep[puffalkepe];
               'ellpuffancs': puffancs[i].kepe:=ellpuffancskep[puffalkepe];
               'ellkozkatona': puffancs[i].kepe:=ellkozkatkep[puffalkepe];
              end;
      end
      else
      begin
       if puffancs[i].kikerirany=0 then
       begin
            joiranydb:=0;
            if ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
            begin
                 iranytomb[joiranydb]:=2; //Fel
                 joiranydb:=joiranydb+1;
            end;
            if ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
            begin
                 iranytomb[joiranydb]:=4; //Le
                 joiranydb:=joiranydb+1;
            end;
            if ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
            begin
                 iranytomb[joiranydb]:=3; //Balra
                 joiranydb:=joiranydb+1;
            end;
            if ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
            begin
                 iranytomb[joiranydb]:=1; //Jobbra
                 joiranydb:=joiranydb+1;
            end;
            if joiranydb>0 then puffancs[i].kikerirany:=iranytomb[random(joiranydb)]
            else kiutkeres(i,puffancs[i].xhely-round(puffancs[i].kepe.width/2),puffancs[i].yhely-round(puffancs[i].kepe.height/2),puffancs[i].kepe.width,puffancs[i].kepe.height);;
       end
       else
       begin
        kovx:=puffancs[i].xhely;
        kovy:=puffancs[i].yhely;
        case puffancs[i].kikerirany of
          1: begin  //Jobbra:
             if (ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) then
             begin
                  if puffancs[i].kanyardb>random(2) then
                  begin
                     puffancs[i].kikerirany:=0;
                     puffancs[i].kanyardb:=0;
                  end
                  else
                  begin
                   if random(2)=1 then
                   begin
                        kovy:=puffancs[i].yhely-puffancs[i].sebessege;
                        puffancs[i].kikerirany:=2;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end
                   else
                   begin
                        kovy:=puffancs[i].yhely+puffancs[i].sebessege;
                        puffancs[i].kikerirany:=4;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end;
                  end;
             end
             else
             if ((ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) or (ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true)) and (puffancs[i].kanyardb>0) then
             begin
                  puffancs[i].kikerirany:=0;
                  puffancs[i].kanyardb:=0;
             end
             else if ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
             begin
                  kovx:=puffancs[i].xhely+puffancs[i].sebessege;
                  if ponttav(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].elozoxh,puffancs[i].elozoyh)>puffancs[i].kepe.width then
                  begin
                       if ((ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (abs((puffancs[i].yhely-puffancs[i].sebessege)-puffancs[i].cely)<abs(kovy-puffancs[i].cely))) or (ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true and (abs((puffancs[i].yhely+puffancs[i].sebessege)-puffancs[i].cely)<abs(kovy-puffancs[i].cely))) then
                       begin
                            puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                       end;
                       puffancs[i].elozoxh:=puffancs[i].xhely;
                       puffancs[i].elozoyh:=puffancs[i].yhely;
                  end;
             end
             else
             begin
                  puffancs[i].kikerirany:=0;
             end;
          end;
          2: begin //Fel:
             if (ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) then
             begin
                  if puffancs[i].kanyardb>random(2) then
                  begin
                     puffancs[i].kikerirany:=0;
                     puffancs[i].kanyardb:=0;
                  end
                  else
                  begin
                   if random(2)=1 then
                   begin
                        kovx:=puffancs[i].xhely-puffancs[i].sebessege;
                        puffancs[i].kikerirany:=3;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end
                   else
                   begin
                        kovx:=puffancs[i].xhely+puffancs[i].sebessege;
                        puffancs[i].kikerirany:=1;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end;
                  end;
             end
             else
             if ((ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) or (ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true)) and (puffancs[i].kanyardb>0) then
             begin
                  puffancs[i].kikerirany:=0;
                  puffancs[i].kanyardb:=0;
             end
             else if ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
             begin
                  kovy:=puffancs[i].yhely-puffancs[i].sebessege;
                  if ponttav(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].elozoxh,puffancs[i].elozoyh)>puffancs[i].kepe.height then
                  begin
                       if ((ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (abs((puffancs[i].xhely-puffancs[i].sebessege)-puffancs[i].celx)<abs(kovx-puffancs[i].celx))) or (ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true and (abs((puffancs[i].xhely+puffancs[i].sebessege)-puffancs[i].celx)<abs(kovx-puffancs[i].celx))) then
                       begin
                            puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                       end;
                       puffancs[i].elozoxh:=puffancs[i].xhely;
                       puffancs[i].elozoyh:=puffancs[i].yhely;
                  end;
             end
             else
             begin
                  puffancs[i].kikerirany:=0;
             end;
          end;
          3: begin   //Balra:
             if (ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) then
             begin
                  if puffancs[i].kanyardb>random(2) then
                  begin
                     puffancs[i].kikerirany:=0;
                     puffancs[i].kanyardb:=0;
                  end
                  else
                  begin
                   if random(2)=1 then
                   begin
                        kovy:=puffancs[i].yhely-puffancs[i].sebessege;
                        puffancs[i].kikerirany:=2;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end
                   else
                   begin
                        kovy:=puffancs[i].yhely+puffancs[i].sebessege;
                        puffancs[i].kikerirany:=4;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end;
                  end;
             end
             else
             if ((ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) or (ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true)) and (puffancs[i].kanyardb>0) then
             begin
                  puffancs[i].kikerirany:=0;
                  puffancs[i].kanyardb:=0;
             end
             else if ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
             begin
                  kovx:=puffancs[i].xhely-puffancs[i].sebessege;
                  if ponttav(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].elozoxh,puffancs[i].elozoyh)>puffancs[i].kepe.width then
                  begin
                       if ((ureshely(puffancs[i].xhely,puffancs[i].yhely-puffancs[i].kepe.height-puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (abs((puffancs[i].yhely-puffancs[i].sebessege)-puffancs[i].cely)<abs(kovy-puffancs[i].cely))) or (ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true and (abs((puffancs[i].yhely+puffancs[i].sebessege)-puffancs[i].cely)<abs(kovy-puffancs[i].cely))) then
                       begin
                            puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                       end;
                       puffancs[i].elozoxh:=puffancs[i].xhely;
                       puffancs[i].elozoyh:=puffancs[i].yhely;
                  end;
             end
             else
             begin
                  puffancs[i].kikerirany:=0;
             end;
          end;
          4: begin  //Le:
             if (ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) then
             begin
                  if puffancs[i].kanyardb>random(2) then
                  begin
                     puffancs[i].kikerirany:=0;
                     puffancs[i].kanyardb:=0;
                  end
                  else
                  begin
                   if random(2)=1 then
                   begin
                        kovx:=puffancs[i].xhely-puffancs[i].sebessege;
                        puffancs[i].kikerirany:=3;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end
                   else
                   begin
                        kovx:=puffancs[i].xhely+puffancs[i].sebessege;
                        puffancs[i].kikerirany:=1;
                        puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                        puffancs[i].elozoxh:=puffancs[i].xhely;
                        puffancs[i].elozoyh:=puffancs[i].yhely;
                   end;
                  end;
             end
             else
             if ((ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) or (ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true)) and (puffancs[i].kanyardb>0) then
             begin
                  puffancs[i].kikerirany:=0;
                  puffancs[i].kanyardb:=0;
             end
             else if ureshely(puffancs[i].xhely,puffancs[i].yhely+puffancs[i].kepe.height+puffancs[i].sebessege,puffancs[i].kepe.width,puffancs[i].kepe.height)=true then
             begin
                  kovy:=puffancs[i].yhely+puffancs[i].sebessege;
                  if ponttav(puffancs[i].xhely,puffancs[i].yhely,puffancs[i].elozoxh,puffancs[i].elozoyh)>puffancs[i].kepe.height then
                  begin
                       if ((ureshely(puffancs[i].xhely-puffancs[i].kepe.width-puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true) and (abs((puffancs[i].xhely-puffancs[i].sebessege)-puffancs[i].celx)<abs(kovx-puffancs[i].celx))) or (ureshely(puffancs[i].xhely+puffancs[i].kepe.width+puffancs[i].sebessege,puffancs[i].yhely,puffancs[i].kepe.width,puffancs[i].kepe.height)=true and (abs((puffancs[i].xhely+puffancs[i].sebessege)-puffancs[i].celx)<abs(kovx-puffancs[i].celx))) then
                       begin
                            puffancs[i].kanyardb:=puffancs[i].kanyardb+1;
                       end;
                       puffancs[i].elozoxh:=puffancs[i].xhely;
                       puffancs[i].elozoyh:=puffancs[i].yhely;
                  end;
             end
             else
             begin
                  puffancs[i].kikerirany:=0;
             end;
          end;
        end;
        puffancs[i].iranya:=pontirany(puffancs[i].xhely,puffancs[i].yhely,kovx,kovy);
        puffancs[i].xhely:=kovx;
        puffancs[i].yhely:=kovy;
        puffalkepe:=trunc(puffancs[i].iranya*8/360);
        if puffalkepe>7 then puffalkepe:=0;
        case puffancs[i].neve of
          'puffancs': puffancs[i].kepe:=puffancskep[puffalkepe];
          'kozkatona': puffancs[i].kepe:=kozkatkep[puffalkepe];
          'ellpuffancs': puffancs[i].kepe:=ellpuffancskep[puffalkepe];
          'ellkozkatona': puffancs[i].kepe:=ellkozkatkep[puffalkepe];
        end;
       end;
      end;
     end;
     'semmit': begin
      utkellenorzes(i);
      for e:=0 to puffancsdb-1 do
      begin
       if (puffancs[i].tulaj<>puffancs[e].tulaj) and (ponttav(puffancs[i].xhely,puffancs[i].yhely,puffancs[e].xhely,puffancs[e].yhely)<=puffancs[i].lotav) then
       begin
          puffancs[i].celx:=puffancs[e].xhely;
          puffancs[i].cely:=puffancs[e].yhely;
          puffancs[i].celindex:=e;
          puffancs[i].mitcsinal:='visszalo';
       end;
      end;
      vancelpont:=false;
      if (puffancs[i].tulaj<>0) and (random(50)+1=1) and (ellcselekedhet=true) and (puffancs[i].neve<>'puffancs') then
      begin
         for e:=0 to puffancsdb-1 do
         begin
          if (puffancs[i].tulaj<>puffancs[e].tulaj) and (random(5)+1=1) then
          begin
             puffancs[i].celx:=puffancs[e].xhely;
             puffancs[i].cely:=puffancs[e].yhely;
             puffancs[i].celindex:=e;
             puffancs[i].mitcsinal:='uldoz';
             vancelpont:=true;
             break;
          end;
         end;
         if vancelpont=false then
         begin
          for e:=0 to epuletdb-1 do
          begin
           if (puffancs[i].tulaj<>epuletek[e].tulaj) and (random(5)+1=1) then
           begin
             puffancs[i].celx:=epuletek[e].xhely;
             puffancs[i].cely:=epuletek[e].yhely;
             puffancs[i].celindex:=e;
             puffancs[i].mitcsinal:='megybontani';
             break;
           end;
          end;
         end;
      end;
     end;
     'epit': begin
      if (puffcelkozelben(i,0)=true) then
       begin
          if epuletek[puffancs[i].celindex].epsege<epuletek[puffancs[i].celindex].maxepsege then
          begin
             epuletek[puffancs[i].celindex].epsege:=epuletek[puffancs[i].celindex].epsege+1;
             Canvas.Pen.Color:=clRed;
             Canvas.Pen.Width:=2;
             Canvas.MoveTo(palyakepx+puffancs[i].xhely,palyakepy+puffancs[i].yhely);
             Canvas.LineTo(palyakepx+puffancs[i].celx,palyakepy+puffancs[i].cely);
          end
          else
          begin
           for p:=0 to puffancsdb-1 do
           begin
            if puffancs[p].celindex=puffancs[i].celindex then puffancs[p].mitcsinal:='semmit';
           end;
           if epuletek[puffancs[i].celindex].uzemkesz=false then epuletek[puffancs[i].celindex].uzemkesz:=true;
           break;
          end;
       end
       else puffancs[p].mitcsinal:='megyepiteni';
     end;
     'lebont': begin
      for e:=0 to epuletdb-1 do
      begin
       if (puffcelkozelben(i,0)=true) and (puffancs[i].celindex=e) then
       begin
          if epuletek[e].epsege>0 then
          begin
           if epuletek[e].epsege-1>=0 then
             epuletek[e].epsege:=epuletek[e].epsege-1
           else epuletek[e].epsege:=0;
             Canvas.Pen.Color:=clRed;
             Canvas.Pen.Width:=2;
             Canvas.MoveTo(palyakepx+puffancs[i].xhely,palyakepy+puffancs[i].yhely);
             Canvas.LineTo(palyakepx+puffancs[i].celx,palyakepy+puffancs[i].cely);
          end
          else
          begin
           for p:=0 to puffancsdb-1 do
           begin
            if puffancs[p].celindex=e then puffancs[p].mitcsinal:='semmit';
           end;
           epuletek[e].letezik:=false;
           break;
          end;
       end;
      end;
      end;
      'harcol','visszalo': begin
       if puffcelkozelben(i,1)=true then
       begin
          if puffancs[puffancs[i].celindex].epsege>0 then
          begin
           if puffancs[puffancs[i].celindex].epsege-puffancs[i].tamadoero>=0 then
             puffancs[puffancs[i].celindex].epsege:=puffancs[puffancs[i].celindex].epsege-puffancs[i].tamadoero
           else puffancs[puffancs[i].celindex].epsege:=0;
             Canvas.Pen.Color:=clRed;
             Canvas.Pen.Width:=2;
             Canvas.MoveTo(palyakepx+puffancs[i].xhely,palyakepy+puffancs[i].yhely);
             Canvas.LineTo(palyakepx+puffancs[puffancs[i].celindex].xhely,palyakepy+puffancs[puffancs[i].celindex].yhely);
          end
          else
          begin
           for p:=0 to puffancsdb-1 do
           begin
            if puffancs[p].celindex=puffancs[i].celindex then puffancs[p].mitcsinal:='semmit';
           end;
           puffancs[puffancs[i].celindex].letezik:=false;
           break;
          end;
       end
       else if puffancs[i].mitcsinal='harcol' then puffancs[i].mitcsinal:='uldoz';
     end;
    end;
   end;
  end;
  with canvas do invalidate;
end;

procedure TForm1.ellvezerles(Sender: TObject);
begin
  ellcselekedhet:=not(ellcselekedhet);
end;

procedure TForm1.kilepgombkatt(Sender: TObject);
var valasz,stilus: integer;
begin
 stilus:=MB_ICONQUESTION + MB_YESNO;
 case nyelv of
   0: valasz:=Application.MessageBox('Biztosan ki akarsz lépni?', 'Megerősítés', stilus);
   1: valasz:=Application.MessageBox('Are you sure you want to exit?', 'Confirmation', stilus);
 end;
 if valasz=IDYES then close;
end;

procedure TForm1.jatvegegombkatt(Sender: TObject);
begin
 close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: byte;
begin
  randomize;
  BorderStyle:=bsNone;
  WindowState:=wsFullScreen;
  nyelv:=0;
  cselekves:='nincs';
  kijkerkx:=-1;
  kijkerky:=-1;
  width:=Screen.width;
  height:=Screen.height;
  left:=0;
  top:=0;
  palyakep:=TBitmap.Create;
  palyakep.SetSize(width*3,height*4);
  palyakep.canvas.brush.color:=clblue;
  palyakep.canvas.fillrect(0,0,width*3,height*4);
  palyakepx:=0;
  palyakepy:=0;
  hudpanelkep:=TBitmap.Create;
  hudpanelkep.SetSize(width,128);
  hudpanelkep.canvas.brush.color:=clgreen;
  hudpanelkep.canvas.fillrect(0,0,width,height);
  kilepgomb:=TButton.Create(self);
  With kilepgomb do
  begin
      Left:=1;
      top:=Form1.height-127;
      Caption:='Esc: X';
      parent:=self;
      Onclick:=@kilepgombkatt;
      OnKeyDown:=@FormKeyDown
  end;
  for i:=0 to 7 do
  begin
   puffancskep[i]:=TBitmap.Create;
   puffancskep[i].LoadFromFile('egysegek/puffancs/puff'+inttostr(i)+'.bmp');
   puffancskep[i].transparent:=true;
   kozkatkep[i]:=TBitmap.Create;
   kozkatkep[i].LoadFromFile('egysegek/kozkatona/kozkat'+inttostr(i)+'.bmp');
   kozkatkep[i].transparent:=true;
   ellpuffancskep[i]:=TBitmap.Create;
   ellpuffancskep[i].LoadFromFile('egysegek/ellpuffancs/ellpuff'+inttostr(i)+'.bmp');
   ellpuffancskep[i].transparent:=true;
   ellkozkatkep[i]:=TBitmap.Create;
   ellkozkatkep[i].LoadFromFile('egysegek/ellkozkatona/ellkozkat'+inttostr(i)+'.bmp');
   ellkozkatkep[i].transparent:=true;
  end;
  puffancsdb:=0;
  for i:=0 to 1 do
  begin
   egysegcsinalo('puffancs',random(500)+1,random(500)+1,0);
  end;
  foepkep:=TBitmap.Create;
  foepkep.LoadFromFile('epuletek/foepulet.bmp');
  foepkep.transparent:=true;
  lakohazkep:=TBitmap.Create;
  lakohazkep.LoadFromFile('epuletek/lakohaz.bmp');
  lakohazkep.transparent:=true;
  laktkep:=TBitmap.Create;
  laktkep.LoadFromFile('epuletek/laktanya.bmp');
  laktkep.transparent:=true;
  leztorkep:=TBitmap.Create;
  leztorkep.LoadFromFile('epuletek/lezertorony.bmp');
  leztorkep.transparent:=true;
  ellfoepkep:=TBitmap.Create;
  ellfoepkep.LoadFromFile('epuletek/ellfoepulet.bmp');
  ellfoepkep.transparent:=true;
  elllakohazkep:=TBitmap.Create;
  elllakohazkep.LoadFromFile('epuletek/elllakohaz.bmp');
  elllakohazkep.transparent:=true;
  elllaktkep:=TBitmap.Create;
  elllaktkep.LoadFromFile('epuletek/elllaktanya.bmp');
  elllaktkep.transparent:=true;
  ellleztorkep:=TBitmap.Create;
  ellleztorkep.LoadFromFile('epuletek/elllezertorony.bmp');
  ellleztorkep.transparent:=true;
  epuletdb:=0;
  epuletcsinalo('foepulet',800,800,1,0);
  epuletcsinalo('elllaktanya',palyakep.canvas.width-elllaktkep.width*2,palyakep.canvas.height-elllaktkep.height*2,250,1);
  epuletcsinalo('elllezertorony',palyakep.canvas.width-elllaktkep.width*2-ellleztorkep.width*2,palyakep.canvas.height-elllaktkep.height*2-ellleztorkep.height*2,200,1);
  epitikonkep:=TBitmap.Create;
  epitikonkep.LoadFromFile('ikonok/epitikon.bmp');
  lebontikonkep:=TBitmap.Create;
  lebontikonkep.LoadFromFile('ikonok/lebontikon.bmp');
  foepikonkep:=TBitmap.Create;
  foepikonkep.LoadFromFile('ikonok/foepikon.bmp');
  lakohazikonkep:=TBitmap.Create;
  lakohazikonkep.LoadFromFile('ikonok/lakohazikon.bmp');
  laktanyaikonkep:=TBitmap.Create;
  laktanyaikonkep.LoadFromFile('ikonok/laktanyaikon.bmp');
  lezertoronyikonkep:=TBitmap.Create;
  lezertoronyikonkep.LoadFromFile('ikonok/lezertoronyikon.bmp');
  puffikonkep:=TBitmap.Create;
  puffikonkep.LoadFromFile('ikonok/puffikon.bmp');
  kozkatikonkep:=TBitmap.Create;
  kozkatikonkep.LoadFromFile('ikonok/kozkatikon.bmp');
  palyafrissito:=TTimer.Create(nil);
  palyafrissito.interval:=10;
  palyafrissito.ontimer:=@palyafrissites;
  ellvezerlo:=TTimer.Create(nil);
  ellvezerlo.interval:=10000;
  ellvezerlo.ontimer:=@ellvezerles;
  ellcselekedhet:=true;
  gombgazda:=-1;
end;

procedure TForm1.FormDestroy(Sender: TObject);
var i: byte;
begin
  palyakep.Free;
  hudpanelkep.Free;
  foepkep.Free;
  lakohazkep.Free;
  laktkep.Free;
  leztorkep.Free;
  epitikonkep.Free;
  lebontikonkep.Free;
  for i:=0 to 7 do
  begin
   puffancskep[i].free;
   ellpuffancskep[i].free;
   kozkatkep[i].free;
   ellkozkatkep[i].free;
  end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  if Key=VK_RIGHT then
  begin
    if palyakepx+palyakep.canvas.width+4>width then
    begin
      dec(palyakepx,4);
    end;
  end;
  if Key=VK_LEFT then
  begin
    if palyakepx<0 then
    begin
      inc(palyakepx,4);
    end;
  end;
  if Key=VK_DOWN then
  begin
    if palyakepy+palyakep.canvas.height+4>height then
    begin
      dec(palyakepy,4);
    end;
  end;
  if Key=VK_UP then
  begin
    if palyakepy<0 then
    begin
      inc(palyakepy,4);
    end;
  end;
  if Key=VK_ESCAPE then kilepgombkatt(form1);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,j: integer;
    g: byte;
    puffrakatt,eprekatt: boolean;
begin
  if Button=mbLeft then
  begin
    if (epitendo<>nil) and (mouse.cursorpos.Y<Screen.height-hudpanelkep.height) then
    begin
      if (utkitt(abs(palyakepx)+mouse.cursorpos.X,abs(palyakepy)+mouse.cursorpos.Y,epitendo.kepe.width,epitendo.kepe.height)=false) and (ureshely(abs(palyakepx)+mouse.cursorpos.X,abs(palyakepy)+mouse.cursorpos.Y,epitendo.kepe.width,epitendo.kepe.height)=true) then
      begin
           epuletcsinalo(epitendo.neve,abs(palyakepx)+mouse.cursorpos.X,abs(palyakepy)+mouse.cursorpos.Y,1,0);
           epitendo.free;
           epitendo:=nil;
      end;
    end;
    puffrakatt:=false;
    for i:=0 to puffancsdb-1 do
    begin
     if (X>=palyakepx+puffancs[i].xhely-round(puffancs[i].kepe.width/2)) and (X<=palyakepx+puffancs[i].xhely+round(puffancs[i].kepe.width/2)) and (Y>=palyakepy+puffancs[i].yhely-round(puffancs[i].kepe.height/2)) and (Y<=palyakepy+puffancs[i].yhely+round(puffancs[i].kepe.height/2)) then
     begin
          if puffancs[i].kijelolt=true then
          begin
             puffancs[i].kijelolt:=false;
             gombtorles();
          end
          else
          begin
              puffancs[i].kijelolt:=true;
              if puffancs[i].neve='puffancs' then
              begin
                gombkirako(0,-1);
                gombgazda:=i;
              end;
          end;
          if puffancs[i].tulaj<>0 then //Ellenségre kattintott a játékos?
          begin
            for j:=0 to puffancsdb-1 do
            begin //Akkor a játékos összes kijelölt egysége támadja azt meg:
             if (puffancs[j].tulaj=0) and (puffancs[j].kijelolt=true) then
             begin
               puffancs[j].celx:=puffancs[i].xhely;
               puffancs[j].cely:=puffancs[i].yhely;
               puffancs[j].celindex:=i;
               puffancs[j].mitcsinal:='uldoz';
             end;
            end;
          end;
          puffrakatt:=true;
     end;
    end;
    if puffrakatt=false then
    begin
      eprekatt:=false;
      for i:=0 to epuletdb-1 do
      begin
       if (X>=palyakepx+epuletek[i].xhely-round(epuletek[i].kepe.width/2)) and (X<=palyakepx+epuletek[i].xhely+round(epuletek[i].kepe.width/2)) and (Y>=palyakepy+epuletek[i].yhely-round(epuletek[i].kepe.height/2)) and (Y<=palyakepy+epuletek[i].yhely+round(epuletek[i].kepe.height/2)) then
       begin
            if epuletek[i].kijelolt=true then
            begin
               epuletek[i].kijelolt:=false
            end
            else
            begin
                epuletek[i].kijelolt:=true;
                if (cselekves='lebont') or (epuletek[i].tulaj<>0) then
                begin
                    for j:=0 to puffancsdb-1 do
                    begin
                     if (puffancs[j].kijelolt=true) and (puffancs[j].tulaj=0) then
                     begin
                      puffancs[j].celx:=epuletek[i].xhely;
                      puffancs[j].cely:=epuletek[i].yhely;
                      puffancs[j].celindex:=i;
                      puffancs[j].mitcsinal:='megybontani';
                     end;
                    end;
                    cselekves:='nincs';
                end
                else
                if epuletek[i].epsege<epuletek[i].maxepsege then
                begin
                    for j:=0 to puffancsdb-1 do
                    begin
                     if puffancs[j].kijelolt=true then
                     begin
                      puffancs[j].celx:=epuletek[i].xhely;
                      puffancs[j].cely:=epuletek[i].yhely;
                      puffancs[j].celindex:=i;
                      puffancs[j].mitcsinal:='megyepiteni';
                     end;
                    end;
                    cselekves:='nincs';
                end
                else
                begin
                 case epuletek[i].neve of
                   'foepulet': gombkirako(2,i);
                   'laktanya': gombkirako(3,i);
                 end;
                end;
            end;
            eprekatt:=true;
       end;
      end;
      if eprekatt=false then
      begin
        if gombdb>0 then
        begin
          for g:=0 to gombdb-1 do
          begin
               if (X>=gombok[g].xhely) and (X<=gombok[g].xhely+gombok[g].kepe.width) and (Y>=gombok[g].yhely) and (Y<=gombok[g].yhely+gombok[g].kepe.height) then
               begin
                 case gombok[g].neve of
                  'epit': gombkirako(1,-1);
                  'lebont': cselekves:=gombok[g].neve;
                  'puffancs': begin
                       if epuletek[gombok[g].gazdaepulete].kepezpuffdb+1<255 then inc(epuletek[gombok[g].gazdaepulete].kepezpuffdb,1);
                       epuletek[gombok[g].gazdaepulete].mitkepez:='puffancs';
                  end;
                  'kozkatona': begin
                       if epuletek[gombok[g].gazdaepulete].kepezkozkatdb+1<255 then inc(epuletek[gombok[g].gazdaepulete].kepezkozkatdb,1);
                       epuletek[gombok[g].gazdaepulete].mitkepez:='kozkatona';
                  end
                  else epitendocsinalo(gombok[g].neve);
                 end;
               end;
          end;
        end;
        for i:=0 to puffancsdb-1 do
        begin
         if (puffancs[i].kijelolt=true) and (puffancs[i].tulaj=0) and (Y<Form1.height-hudpanelkep.height) then
         begin
          puffancs[i].celx:=X+abs(palyakepx);
          puffancs[i].cely:=Y+abs(palyakepy);
          puffancs[i].mitcsinal:='megy';
         end;
        end;
        kijkerkx:=X;
        kijkerky:=Y;
        kijkervx:=X;
        kijkervy:=Y;
      end;
    end;
  end
  else if Button=mbRight then
  begin
       cselekves:='nincs';
       for i:=0 to puffancsdb-1 do
       begin
           if puffancs[i].kijelolt=true then puffancs[i].kijelolt:=false;
       end;
       puffrakatt:=false; //Ez most itt gombrakattintást vezérel, bár a neve puffrakatt, de ide csak ezért nem akartam új változót berakni.
       if gombdb>0 then
       begin
          for g:=0 to gombdb-1 do
          begin
               if (X>=gombok[g].xhely) and (X<=gombok[g].xhely+gombok[g].kepe.width) and (Y>=gombok[g].yhely) and (Y<=gombok[g].yhely+gombok[g].kepe.height) then
               begin
                 case gombok[g].neve of
                  'puffancs': begin
                       if epuletek[gombok[g].gazdaepulete].kepezpuffdb-1>=0 then dec(epuletek[gombok[g].gazdaepulete].kepezpuffdb,1);
                       puffrakatt:=true;
                  end;
                  'kozkatona': begin
                       if epuletek[gombok[g].gazdaepulete].kepezkozkatdb-1>=0 then dec(epuletek[gombok[g].gazdaepulete].kepezkozkatdb,1);
                       puffrakatt:=true;
                  end;
                 end;
               end;
          end;
       end;
       if puffrakatt=false then
       begin
            gombtorles();
            for i:=0 to epuletdb-1 do
            begin
                 if epuletek[i].kijelolt=true then epuletek[i].kijelolt:=false;
            end;
            if epitendo<>nil then
            begin
                 epitendo.free;
                 epitendo:=nil;
            end;
       end;
  end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if kijkerkx<>-1 then
  begin
   kijkervx:=X;
   kijkervy:=Y;
  end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i,kx,ky,vx,vy: integer;
begin
  if kijkerkx<>-1 then
  begin
    kx:=min(kijkerkx,kijkervx);
    ky:=min(kijkerky,kijkervy);
    vx:=max(kijkerkx,kijkervx);
    vy:=max(kijkerky,kijkervy);
    for i:=0 to puffancsdb-1 do
    begin
     if (palyakepx+puffancs[i].xhely-round(puffancs[i].kepe.width/2)>=kx) and (palyakepx+puffancs[i].xhely-round(puffancs[i].kepe.width/2)<=vx) and (palyakepy+puffancs[i].yhely-round(puffancs[i].kepe.height/2)>=ky) and (palyakepy+puffancs[i].yhely-round(puffancs[i].kepe.height/2)<=vy) then puffancs[i].kijelolt:=true;
    end;
    kijkerkx:=-1;
    kijkerky:=-1;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
var i,kx,ky,vx,vy: integer;
    gombinfoszoveg: array [0..1] of string;
    g: byte;
    r: trect;
begin
  canvas.draw(palyakepx,palyakepy,palyakep);
  for i:=0 to puffancsdb-1 do
  begin
    canvas.draw(palyakepx+puffancs[i].xhely-round(puffancs[i].kepe.width/2),palyakepy+puffancs[i].yhely-round(puffancs[i].kepe.height/2),puffancs[i].kepe);
    if puffancs[i].kijelolt=true then
    begin
      r:=rect(palyakepx+puffancs[i].xhely-round(puffancs[i].kepe.width/2),palyakepy+puffancs[i].yhely-round(puffancs[i].kepe.height/2),palyakepx+puffancs[i].xhely+round(puffancs[i].kepe.width/2),palyakepy+puffancs[i].yhely+round(puffancs[i].kepe.height/2));
      canvas.drawfocusrect(r); //A szaggatott vonalú kijelölőtéglalap rajzolása
      epsegmutato(palyakepx+puffancs[i].xhely-round(puffancs[i].kepe.width/2),palyakepy+puffancs[i].yhely-round(puffancs[i].kepe.height/2),puffancs[i].kepe.width,puffancs[i].epsege,puffancs[i].maxepsege);
    end;
  end;
  for i:=0 to epuletdb-1 do
  begin
    canvas.draw(palyakepx+epuletek[i].xhely-round(epuletek[i].kepe.width/2),palyakepy+epuletek[i].yhely-round(epuletek[i].kepe.height/2),epuletek[i].kepe);
    if epuletek[i].kijelolt=true then
    begin
      r:=rect(palyakepx+epuletek[i].xhely-round(epuletek[i].kepe.width/2),palyakepy+epuletek[i].yhely-round(epuletek[i].kepe.height/2),palyakepx+epuletek[i].xhely+round(epuletek[i].kepe.width/2),palyakepy+epuletek[i].yhely+round(epuletek[i].kepe.height/2));
      canvas.drawfocusrect(r);
      epsegmutato(palyakepx+epuletek[i].xhely-round(epuletek[i].kepe.width/2),palyakepy+epuletek[i].yhely-round(epuletek[i].kepe.height/2),epuletek[i].kepe.width,epuletek[i].epsege,epuletek[i].maxepsege);
    end;
  end;
  if kijkerkx<>-1 then
  begin
    kx:=min(kijkerkx,kijkervx);
    ky:=min(kijkerky,kijkervy);
    vx:=max(kijkerkx,kijkervx);
    vy:=max(kijkerky,kijkervy);
    r:=rect(kx,ky,vx,vy);
    canvas.drawfocusrect(r);
  end;
  canvas.draw(0,canvas.height-hudpanelkep.height,hudpanelkep);
  if gombdb>0 then
  begin
    for g:=0 to gombdb-1 do
    begin
     canvas.draw(gombok[g].xhely,gombok[g].yhely,gombok[g].kepe);
     if (mouse.cursorpos.X>=gombok[g].xhely) and (mouse.cursorpos.X<=gombok[g].xhely+gombok[g].kepe.width) and (mouse.cursorpos.Y>=gombok[g].yhely) and (mouse.cursorpos.Y<=gombok[g].yhely+gombok[g].kepe.height) then
     begin
          case gombok[g].neve of
           'epit': begin
                   gombinfoszoveg[0]:='Építés';
                   gombinfoszoveg[1]:='Building';
            end;
           'lebont': begin
                   gombinfoszoveg[0]:='Lebontás';
                   gombinfoszoveg[1]:='Demolition';
            end;
           'foepulet': begin
                   gombinfoszoveg[0]:='Városháza';
                   gombinfoszoveg[1]:='Town hall';
            end;
           'lakohaz': begin
                   gombinfoszoveg[0]:='Ház';
                   gombinfoszoveg[1]:='House';
            end;
           'laktanya': begin
                   gombinfoszoveg[0]:='Laktanya';
                   gombinfoszoveg[1]:='Barracks';
            end;
           'lezertorony': begin
                   gombinfoszoveg[0]:='Lézer torony';
                   gombinfoszoveg[1]:='Laser tower';
            end;
           'puffancs': begin
                   gombinfoszoveg[0]:='Munkás';
                   gombinfoszoveg[1]:='Worker';
                   if epuletek[gombok[g].gazdaepulete].kepezpuffdb>0 then canvas.textout(gombok[g].xhely+120,gombok[g].yhely,inttostr(epuletek[gombok[g].gazdaepulete].kepezpuffdb));
            end;
           'kozkatona': begin
                   gombinfoszoveg[0]:='Közlegény';
                   gombinfoszoveg[1]:='Private';
                   if epuletek[gombok[g].gazdaepulete].kepezkozkatdb>0 then canvas.textout(gombok[g].xhely+120,gombok[g].yhely,inttostr(epuletek[gombok[g].gazdaepulete].kepezkozkatdb));
            end;
          end;
          canvas.textout(gombok[g].xhely,gombok[g].yhely,gombinfoszoveg[nyelv]);
     end;
    end;
  end;
  if epitendo<>nil then canvas.draw(mouse.cursorpos.X-round(epitendo.kepe.width/2),mouse.cursorpos.Y-round(epitendo.kepe.height/2),epitendo.kepe);
end;

end.

